import { world, system, EquipmentSlot, ItemStack, Player, EntityComponentTypes } from '@minecraft/server'

world.afterEvents.playerPlaceBlock.subscribe(data => {
    const player = data.player
    const chance = Math.random()
    const playerEquipment = player.getComponent('equippable')
    if (playerEquipment.getEquipment(EquipmentSlot.Head)?.typeId == 'v360:amethyst_helmet' && playerEquipment.getEquipment(EquipmentSlot.Chest)?.typeId == 'v360:amethyst_chestplate' && playerEquipment.getEquipment(EquipmentSlot.Legs)?.typeId == 'v360:amethyst_leggings' && playerEquipment.getEquipment(EquipmentSlot.Feet)?.typeId == 'v360:amethyst_boots' && chance < 0.4
    ) {
        player.dimension.spawnEntity('minecraft:xp_orb', player.location)
    }
})

world.afterEvents.playerBreakBlock.subscribe(data => {
    const player = data.player
    const chance = Math.random()
    const playerEquipment = player.getComponent('equippable')
    if (playerEquipment.getEquipment(EquipmentSlot.Head)?.typeId == 'v360:amethyst_helmet' && playerEquipment.getEquipment(EquipmentSlot.Chest)?.typeId == 'v360:amethyst_chestplate' && playerEquipment.getEquipment(EquipmentSlot.Legs)?.typeId == 'v360:amethyst_leggings' && playerEquipment.getEquipment(EquipmentSlot.Feet)?.typeId == 'v360:amethyst_boots' && chance < 0.4
    ) {
        player.dimension.spawnEntity('minecraft:xp_orb', player.location)
    }
})

world.afterEvents.entityHurt.subscribe(data => {
    const entity = data.hurtEntity
    const chance = Math.random()
    const playerEquipment = entity.getComponent('equippable')
    if (entity?.hasComponent('equippable') && playerEquipment.getEquipment(EquipmentSlot.Head)?.typeId == 'v360:amethyst_helmet' && playerEquipment.getEquipment(EquipmentSlot.Chest)?.typeId == 'v360:amethyst_chestplate' && playerEquipment.getEquipment(EquipmentSlot.Legs)?.typeId == 'v360:amethyst_leggings' && playerEquipment.getEquipment(EquipmentSlot.Feet)?.typeId == 'v360:amethyst_boots'
    ) {
        entity.dimension.spawnEntity('minecraft:xp_orb', entity.location)
    }
})

world.afterEvents.entityHitEntity.subscribe(data => {
    const entity = data.damagingEntity
    const chance = Math.random()
    const playerEquipment = entity.getComponent('equippable')
    if (entity?.hasComponent('equippable') && playerEquipment.getEquipment(EquipmentSlot.Head)?.typeId == 'v360:amethyst_helmet' && playerEquipment.getEquipment(EquipmentSlot.Chest)?.typeId == 'v360:amethyst_chestplate' && playerEquipment.getEquipment(EquipmentSlot.Legs)?.typeId == 'v360:amethyst_leggings' && playerEquipment.getEquipment(EquipmentSlot.Feet)?.typeId == 'v360:amethyst_boots'
    ) {
        entity.dimension.spawnEntity('minecraft:xp_orb', entity.location)
    }
})

world.afterEvents.entityHitEntity.subscribe(data => {
    const entity = data.damagingEntity
    const player = data.hitEntity
    const chance = Math.random()
    const playerEquipment = player.getComponent('equippable')
    if (player?.hasComponent('equippable') && playerEquipment.getEquipment(EquipmentSlot.Head)?.typeId == 'v360:amethyst_helmet' && playerEquipment.getEquipment(EquipmentSlot.Chest)?.typeId == 'v360:amethyst_chestplate' && playerEquipment.getEquipment(EquipmentSlot.Legs)?.typeId == 'v360:amethyst_leggings' && playerEquipment.getEquipment(EquipmentSlot.Feet)?.typeId == 'v360:amethyst_boots' && chance < 0.7
    ) {
        entity.applyDamage(5)
    }
})