import { world, system } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:amethyst_dagger', {
        onHitEntity({ attackingEntity }) {
            const selectedItem = attackingEntity.getComponent('equippable').getEquipment('Mainhand')
            const { x, y, z } = attackingEntity.getHeadLocation()
            if (attackingEntity && selectedItem?.typeId === 'v360:amethyst_dagger') {
                const spwanLoc = { x: x, y: y + 1, z: z }
                const viewDir = attackingEntity.getViewDirection()
                const jadeDagger = attackingEntity.dimension.spawnEntity("v360:amethyst_dagger", spwanLoc)
                const projectile = jadeDagger.getComponent("projectile")
                projectile.owner = attackingEntity
                projectile.shoot(viewDir)
            }
        }
    })
})

world.afterEvents.projectileHitEntity.subscribe((data) => {
    const projectile = data.projectile
    const shooter = data.source
    const { x, y, z } = shooter?.location
    const target = data.getEntityHit()
    const targLoc = target.entity.location
    const chance = Math.random()
    if (projectile?.typeId === 'v360:amethyst_dagger') {
        if (chance < 0.70) {
            shooter.teleport({ x: targLoc.x, y: targLoc.y, z: targLoc.z })
            target.entity.dimension.spawnParticle('v360:amethyst', shooter.location)
            shooter.dimension.playSound('chime.amethyst_block', shooter.location)
            shooter.runCommand(`effect @e[r=2,type=!player] weakness 5 4 false`)
        }
        else { }
    }
})