import { world, BlockPermutation } from '@minecraft/server';

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent('v360:araucaria_log', {
        onPlayerInteract(e) {
            const { block, player } = e;
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (!selectedItem?.hasTag('minecraft:is_axe')) return;
            const blockState = block.permutation.getState("minecraft:block_face");
            if (blockState) {
                const strippedLog = BlockPermutation.resolve('v360:stripped_araucaria_log', { "minecraft:block_face": blockState });
                block.setPermutation(strippedLog);
            }
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:araucaria_log_destroy', {
        onPlayerDestroy: ({ block }) => {
            const { x, y, z } = block.location
            const placedBlockPerm = BlockPermutation.resolve("v360:decay_araucaria_leaves", { "v360:should_decay": true })
            const replacedBlockPerm = BlockPermutation.resolve("v360:decay_araucaria_leaves", { "v360:should_decay": false })
            block.dimension.runCommand(`fill ${x - 3} ${y - 3} ${z - 3} ${x + 3} ${y + 3} ${z + 3} v360:decay_araucaria_leaves["v360:should_decay"=true] replace v360:decay_araucaria_leaves["v360:should_decay"=false]`)
        }
    })
})