import { world, system, ItemStack } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:cracked_block', {
        onPlayerInteract({ block, player }) {
            const { x, y, z } = block.location
            const selectedItem = player.getComponent('equippable').getEquipment("Mainhand")
            if (selectedItem?.typeId === 'v360:chisel') {
                if (block?.typeId === 'v360:cracked_stone') {
                    block.dimension.runCommand(`loot spawn ${x} ${y} ${z} loot cracked_stone`)
                    block.setType('minecraft:stone')
                }
                else if (block?.typeId === 'v360:cracked_deepslate') {
                    block.dimension.runCommand(`loot spawn ${x} ${y} ${z} loot cracked_deepslate`)
                    block.setType('minecraft:deepslate')
                }
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:chisel', {
        onUseOn({ player: source, block }) {
            if (block.typeId === 'minecraft:stone') {
                block.setType('minecraft:chiseled_stone_bricks')
            }
            else if (block.typeId === 'minecraft:polished_deepslate') {
                block.setType('minecraft:chiseled_deepslate')
            }
            else if (block.typeId === 'minecraft:polished_blackstone') {
                block.setType('minecraft:chiseled_polished_blackstone')
            }
            else if (block.typeId === 'minecraft:nether_brick') {
                block.setType('minecraft:chiseled_nether_bricks')
            }
            else if (block.typeId === 'minecraft:polished_tuff') {
                block.setType('minecraft:chiseled_tuff')
            }
            else if (block.typeId === 'minecraft:tuff_bricks') {
                block.setType('minecraft:chiseled_tuff_brick')
            }
            else if (block.typeId === 'v360:polished_calcite') {
                block.setType('v360:chiseled_calcite')
            }
            else if (block.typeId === 'v360:polished_amphibolite') {
                block.setType('v360:chiseled_amphibolite')
            }
            else if (block.typeId === 'v360:polished_limestone') {
                block.setType('v360:chiseled_limestone')
            }
            else if (block.typeId === 'v360:dripstone_bricks') {
                block.setType('v360:chiseled_dripstone_brick')
            }
            else if (block.typeId === 'v360:polished_rootstone') {
                block.setType('v360:chiseled_rootstone')
            }
            else if (block.typeId === 'minecraft:polished_granite') {
                block.setType('v360:chiseled_granite')
            }
            else if (block.typeId === 'minecraft:polished_diorite') {
                block.setType('v360:chiseled_diorite')
            }
            else if (block.typeId === 'minecraft:polished_andesite') {
                block.setType('v360:chiseled_andesite')
            }
            else if (block.typeId === 'v360:polished_frostone') {
                block.setType('v360:chiseled_frostone')
            }
            else if (block.typeId === 'v360:polished_smooth_basalt') {
                block.setType('v360:chiseled_smooth_basalt_bricks')
            }
            else if (block.typeId === 'v360:polished_end_stone') {
                block.setType('v360:chiseled_end_stone')
            }
            else if (block.typeId === 'v360:polished_amethyst') {
                block.setType('v360:chiseled_amethyst')
            }
            else if (block.typeId === 'v360:polished_citrine') {
                block.setType('v360:chiseled_citrine')
            }
            else if (block.typeId === 'v360:polished_garnet') {
                block.setType('v360:chiseled_garnet')
            }
            else if (block.typeId === 'v360:polished_jade') {
                block.setType('v360:chiseled_jade')
            }
            else if (block.typeId === 'v360:block_of_bronze') {
                block.setType('v360:chiseled_bronze')
            }
            else if (block.typeId === 'minecraft:cut_sandstone') {
                block.setType('v360:sandstone_glyphs')
            }
            else if (block.typeId === 'v360:sandstone_bricks') {
                block.setType('v360:sandstone_glyphs_brick')
            }
            else if (block.typeId === 'minecraft:copper_block') {
                block.setType('minecraft:chiseled_copper')
            }
            else if (block.typeId === 'minecraft:exposed_copper') {
                block.setType('minecraft:exposed_chiseled_copper')
            }
            else if (block.typeId === 'minecraft:weathered_copper') {
                block.setType('minecraft:weathered_chiseled_copper')
            }
            else if (block.typeId === 'minecraft:oxidized_copper') {
                block.setType('minecraft:oxidized_chiseled_copper')
            }
            else if (block.typeId === 'minecraft:waxed_copper') {
                block.setType('minecraft:waxed_chiseled_copper')
            }
            else if (block.typeId === 'minecraft:waxed_exposed_copper') {
                block.setType('minecraft:waxed_exposed_chiseled_copper')
            }
            else if (block.typeId === 'minecraft:waxed_weathered_copper') {
                block.setType('minecraft:waxed_weathered_chiseled_copper')
            }
            else if (block.typeId === 'minecraft:waxed_oxidized_copper') {
                block.setType('minecraft:waxed_oxidized_chiseled_copper')
            }
        }
    })
})