import { world, system, ItemStack } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:chiseled_smooth_basalt_bricks', {
        onPlayerInteract({ block, player }) {
            const { x, y, z } = block.location
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.typeId === 'minecraft:amethyst_shard') {
                block.setType('v360:amethyst_chiseled_smooth_basalt_bricks')
                block.dimension.playSound('respawn_anchor.charge', block.location)
                block.dimension.spawnParticle('v360:amethyst_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s minecraft:amethyst_shard 0 1`)
                }
            }
            if (selectedItem?.typeId === 'v360:citrine_shard') {
                block.setType('v360:citrine_chiseled_smooth_basalt_bricks')
                block.dimension.playSound('respawn_anchor.charge', block.location)
                block.dimension.spawnParticle('v360:citrine_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s v360:citrine_shard 0 1`)
                }
            }
            if (selectedItem?.typeId === 'v360:garnet_shard') {
                block.setType('v360:garnet_chiseled_smooth_basalt_bricks')
                block.dimension.playSound('respawn_anchor.charge', block.location)
                block.dimension.spawnParticle('v360:garnet_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s v360:garnet_shard 0 1`)
                }
            }
            if (selectedItem?.typeId === 'v360:jade_shard') {
                block.setType('v360:jade_chiseled_smooth_basalt_bricks')
                block.dimension.playSound('respawn_anchor.charge', block.location)
                block.dimension.spawnParticle('v360:jade_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s v360:jade_shard 0 1`)
                }
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:amethyst_chiseled_smooth_basalt_brick', {
        onPlayerInteract({ block, player }) {
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.typeId === 'v360:chisel') {
                block.setType('v360:chiseled_smooth_basalt_bricks')
                block.dimension.spawnItem(new ItemStack('minecraft:amethyst_shard', 1), block.center())
                block.dimension.playSound('respawn_anchor.deplete', block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:citrine_chiseled_smooth_basalt_brick', {
        onPlayerInteract({ block, player }) {
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.typeId === 'v360:chisel') {
                block.setType('v360:chiseled_smooth_basalt_bricks')
                block.dimension.spawnItem(new ItemStack('v360:citrine_shard', 1), block.center())
                block.dimension.playSound('respawn_anchor.deplete', block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:garnet_chiseled_smooth_basalt_brick', {
        onPlayerInteract({ block, player }) {
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.typeId === 'v360:chisel') {
                block.setType('v360:chiseled_smooth_basalt_bricks')
                block.dimension.spawnItem(new ItemStack('v360:garnet_shard', 1), block.center())
                block.dimension.playSound('respawn_anchor.deplete', block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:jade_chiseled_smooth_basalt_brick', {
        onPlayerInteract({ block, player }) {
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.typeId === 'v360:chisel') {
                block.setType('v360:chiseled_smooth_basalt_bricks')
                block.dimension.spawnItem(new ItemStack('v360:jade_shard', 1), block.center())
                block.dimension.playSound('respawn_anchor.deplete', block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:rainbow_chiseled_smooth_basalt_brick', {
        onTick({ block }) {
            const { x, y, z } = block.location
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace torch`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace soul_torch`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace v360:copper_torch`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace torch`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} basalt [] replace flowing_lava`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:unlit_lantern["minecraft:block_face"="up"] replace lantern["hanging"=false]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:unlit_lantern["minecraft:block_face"="down"] replace lantern["hanging"=true]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:unlit_lantern["minecraft:block_face"="up"] replace soul_lantern["hanging"=false]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:unlit_lantern["minecraft:block_face"="down"] replace soul_lantern["hanging"=true]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:unlit_lantern["minecraft:block_face"="up"] replace v360:lush_lantern["minecraft:block_face"="up"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:unlit_lantern["minecraft:block_face"="down"] replace v360:lush_lantern["minecraft:block_face"="down"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:unlit_lantern["minecraft:block_face"="up"] replace v360:copper_lantern["minecraft:block_face"="up"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:unlit_lantern["minecraft:block_face"="down"] replace v360:copper_lantern["minecraft:block_face"="down"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace glowstone`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace lit_redstone_lamp`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace beacon`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace sea_lantern`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace redstone_torch`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace v360:enderlight`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace sculk_catalyst`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace shroomlight`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} air [] replace ochre_froglight`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} campfire ["extinguished"=true,"minecraft:cardinal_direction"="north"] replace campfire ["extinguished"=false,"minecraft:cardinal_direction"="north"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} campfire ["extinguished"=true,"minecraft:cardinal_direction"="south"] replace campfire ["extinguished"=false,"minecraft:cardinal_direction"="south"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} campfire ["extinguished"=true,"minecraft:cardinal_direction"="west"] replace campfire ["extinguished"=false,"minecraft:cardinal_direction"="west"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} campfire ["extinguished"=true,"minecraft:cardinal_direction"="east"] replace campfire ["extinguished"=false,"minecraft:cardinal_direction"="east"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} soul_campfire ["extinguished"=true,"minecraft:cardinal_direction"="north"] replace soul_campfire ["extinguished"=false,"minecraft:cardinal_direction"="north"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} soul_campfire ["extinguished"=true,"minecraft:cardinal_direction"="south"] replace soul_campfire ["extinguished"=false,"minecraft:cardinal_direction"="south"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} soul_campfire ["extinguished"=true,"minecraft:cardinal_direction"="west"] replace soul_campfire ["extinguished"=false,"minecraft:cardinal_direction"="west"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} soul_campfire ["extinguished"=true,"minecraft:cardinal_direction"="east"] replace soul_campfire ["extinguished"=false,"minecraft:cardinal_direction"="east"]`)


            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:copper_campfire ["v360:extinguished"=true,"minecraft:cardinal_direction"="north"] replace v360:copper_campfire ["v360:extinguished"=false,"minecraft:cardinal_direction"="north"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:copper_campfire ["v360:extinguished"=true,"minecraft:cardinal_direction"="south"] replace v360:copper_campfire ["v360:extinguished"=false,"minecraft:cardinal_direction"="south"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:copper_campfire ["v360:extinguished"=true,"minecraft:cardinal_direction"="west"] replace v360:copper_campfire ["v360:extinguished"=false,"minecraft:cardinal_direction"="west"]`)
            block.dimension.runCommand(`fill ${x - 10} ${y - 5} ${z - 10} ${x + 10} ${y + 5} ${z + 10} v360:copper_campfire ["v360:extinguished"=true,"minecraft:cardinal_direction"="east"] replace v360:copper_campfire ["v360:extinguished"=false,"minecraft:cardinal_direction"="east"]`)
            if (block.below().typeId === 'v360:smooth_basalt_bricks' && (block.above().typeId === 'v360:empty_rainbow_lamp' || block.above().typeId === 'v360:rainbow_lamp')) {
                block.dimension.getEntities({ type: 'minecraft:zombie', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:husk', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:drowned', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:skeleton', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:stray', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:bogged', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:creeper', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:spider', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'v360:frostbyte', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:enderman', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:zombie_villager', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
                block.dimension.getEntities({ type: 'minecraft:slime', location: block.location, maxDistance: 15 }).forEach(
                    (data) => {
                        data.teleport({ x: x, y: -64, z: z })
                    }
                )
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:inactive_rainbow_chiseled_smooth_basalt_brick', {
        onPlayerInteract({ block, player }) {
            const { x, y, z } = block.location
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.typeId === 'v360:rainbow_shard') {
                block.setType('v360:rainbow_chiseled_smooth_basalt_bricks')
                block.dimension.playSound('respawn_anchor.charge', block.location)
                block.dimension.spawnParticle('v360:rainbow_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s v360:rainbow_shard 0 1`)
                }
            }
        }
    })
})