import { world, system, ItemStack, BlockPermutation } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:copper_barrel', {
        onTick(data) {
            const { block, player } = data
            block.setType('v360:exposed_copper_barrel')
        },
        onPlayerInteract(data) {
            const { block, player } = data
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === 'minecraft:honeycomb') {
                const { x, y, z } = block.location
                block.setType('v360:waxed_copper_barrel')
                block.dimension.runCommand(`particle v360:wax ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.on", block.location)
                if (player.getGameMode() !== "creative") {
                    player.runCommandAsync('clear @s minecraft:honeycomb 0 1')
                }
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:exposed_copper_barrel', {
        onTick(data) {
            const { block, player } = data
            block.setType('v360:weathred_copper_barrel')
        },
        onPlayerInteract(data) {
            const { block, player } = data
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === 'minecraft:honeycomb') {
                const { x, y, z } = block.location
                block.setType('v360:waxed_exposed_copper_barrel')
                block.dimension.runCommand(`particle v360:wax ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.on", block.location)
                if (player.getGameMode() !== "creative") {
                    player.runCommandAsync('clear @s minecraft:honeycomb 0 1')
                }
            }
            else if (selectedItem?.hasTag('minecraft:is_axe')) {
                const { x, y, z } = block.location
                block.setType('v360:copper_barrel')
                block.dimension.runCommand(`particle v360:oxidization_off ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.off", block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:weathered_copper_barrel', {
        onTick(data) {
            const { block, player } = data
            block.setType('v360:oxidized_copper_barrel')
        },
        onPlayerInteract(data) {
            const { block, player } = data
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === 'minecraft:honeycomb') {
                const { x, y, z } = block.location
                block.setType('v360:waxed_weathered_copper_barrel')
                block.dimension.runCommand(`particle v360:wax ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.on", block.location)
                if (player.getGameMode() !== "creative") {
                    player.runCommandAsync('clear @s minecraft:honeycomb 0 1')
                }
            }
            else if (selectedItem?.hasTag('minecraft:is_axe')) {
                const { x, y, z } = block.location
                block.setType('v360:exposed_copper_barrel')
                block.dimension.runCommand(`particle v360:oxidization_off ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.off", block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:oxidized_copper_barrel', {
        onPlayerInteract(data) {
            const { block, player } = data
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.typeId === 'minecraft:honeycomb') {
                const { x, y, z } = block.location
                block.setType('v360:waxed_oxidized_copper_barrel')
                block.dimension.runCommand(`particle v360:wax ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.on", block.location)
                if (player.getGameMode() !== "creative") {
                    player.runCommandAsync('clear @s minecraft:honeycomb 0 1')
                }
            }
            else if (selectedItem?.hasTag('minecraft:is_axe')) {
                const { x, y, z } = block.location
                block.setType('v360:weathered_copper_barrel')
                block.dimension.runCommand(`particle v360:oxidization_off ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.off", block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:waxed_copper_barrel', {
        onPlayerInteract(data) {
            const { block, player } = data
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.hasTag('minecraft:is_axe')) {
                const { x, y, z } = block.location
                block.setType('v360:copper_barrel')
                block.dimension.runCommand(`particle v360:wax_off ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.off", block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:waxed_exposed_copper_barrel', {
        onPlayerInteract(data) {
            const { block, player } = data
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.hasTag('minecraft:is_axe')) {
                const { x, y, z } = block.location
                block.setType('v360:exposed_copper_barrel')
                block.dimension.runCommand(`particle v360:wax_off ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.off", block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:waxed_weathered_copper_barrel', {
        onPlayerInteract(data) {
            const { block, player } = data
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.hasTag('minecraft:is_axe')) {
                const { x, y, z } = block.location
                block.setType('v360:weathered_copper_barrel')
                block.dimension.runCommand(`particle v360:wax_off ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.off", block.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:waxed_oxidized_copper_barrel', {
        onPlayerInteract(data) {
            const { block, player } = data
            const equipment = player.getComponent('equippable');
            const selectedItem = equipment.getEquipment('Mainhand');
            if (selectedItem?.hasTag('minecraft:is_axe')) {
                const { x, y, z } = block.location
                block.setType('v360:oxidized_copper_barrel')
                block.dimension.runCommand(`particle v360:wax_off ${x} ${y + 0.5} ${z}`)
                block.dimension.playSound("copper.wax.off", block.location)
            }
        }
    })
})