import { world, system, ItemStack, BlockPermutation } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:empty_crystal_lamp', {
        onPlayerInteract({ block, player }) {
            const { x, y, z } = block.location
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.typeId === 'minecraft:amethyst_shard') {
                block.setType('v360:amethyst_lamp')
                block.dimension.spawnEntity('v360:crystal_golem_activator', block.center()).triggerEvent('amethyst_activator')
                block.dimension.spawnParticle('v360:amethyst_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                block.dimension.playSound('resonate.amethyst_block', block.location)
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s minecraft:amethyst_shard 0 1`)
                }
            }
            if (selectedItem?.typeId === 'v360:citrine_shard') {
                block.setType('v360:citrine_lamp')
                block.dimension.spawnEntity('v360:crystal_golem_activator', block.center()).triggerEvent('citrine_activator')
                block.dimension.spawnParticle('v360:citrine_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                block.dimension.playSound('resonate.amethyst_block', block.location)
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s v360:citrine_shard 0 1`)
                }
            }
            if (selectedItem?.typeId === 'v360:garnet_shard') {
                block.setType('v360:garnet_lamp')
                block.dimension.spawnEntity('v360:crystal_golem_activator', block.center()).triggerEvent('garnet_activator')
                block.dimension.spawnParticle('v360:garnet_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                block.dimension.playSound('resonate.amethyst_block', block.location)
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s v360:garnet_shard 0 1`)
                }
            }
            if (selectedItem?.typeId === 'v360:jade_shard') {
                block.setType('v360:jade_lamp')
                block.dimension.spawnEntity('v360:crystal_golem_activator', block.center()).triggerEvent('jade_activator')
                block.dimension.spawnParticle('v360:jade_chiseled_smooth_basalt_brick', { x: x, y: y + 0.5, z: z })
                block.dimension.playSound('resonate.amethyst_block', block.location)
                if (player.getGameMode() !== 'creative') {
                    player.runCommand(`clear @s v360:jade_shard 0 1`)
                }
            }
        }
    })
})