import { world, system, ItemStack } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:entity_spawner', {
        onTick({ block }) {
            const { x, y, z } = block.location
            if (block.hasTag('v360:goblin')) {
                if (block.hasTag('v360:enorth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:goblin ${x} ${y} ${z} 0 ~`)
                }
                else if (block.hasTag('v360:esouth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:goblin ${x} ${y} ${z} 180 ~`)
                }
                else if (block.hasTag('v360:ewest')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:goblin ${x} ${y} ${z} -90 ~`)
                }
                else if (block.hasTag('v360:eeast')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:goblin ${x} ${y} ${z} 90 ~`)
                }
            }
            if (block.hasTag('v360:amethyst_crystal_golem')) {
                if (block.hasTag('v360:enorth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:amethyst_crystal_golem ${x} ${y} ${z} 0 ~`)
                }
                else if (block.hasTag('v360:esouth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:amethyst_crystal_golem ${x} ${y} ${z} 180 ~`)
                }
                else if (block.hasTag('v360:ewest')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:amethyst_crystal_golem ${x} ${y} ${z} -90 ~`)
                }
                else if (block.hasTag('v360:eeast')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:amethyst_crystal_golem ${x} ${y} ${z} 90 ~`)
                }
            }
            if (block.hasTag('v360:citrine_crystal_golem')) {
                if (block.hasTag('v360:enorth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:citrine_crystal_golem ${x} ${y} ${z} 0 ~`)
                }
                else if (block.hasTag('v360:esouth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:citrine_crystal_golem ${x} ${y} ${z} 180 ~`)
                }
                else if (block.hasTag('v360:ewest')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:citrine_crystal_golem ${x} ${y} ${z} -90 ~`)
                }
                else if (block.hasTag('v360:eeast')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:citrine_crystal_golem ${x} ${y} ${z} 90 ~`)
                }
            }
            if (block.hasTag('v360:garnet_crystal_golem')) {
                if (block.hasTag('v360:enorth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:garnet_crystal_golem ${x} ${y} ${z} 0 ~`)
                }
                else if (block.hasTag('v360:esouth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:garnet_crystal_golem ${x} ${y} ${z} 180 ~`)
                }
                else if (block.hasTag('v360:ewest')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:garnet_crystal_golem ${x} ${y} ${z} -90 ~`)
                }
                else if (block.hasTag('v360:eeast')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:garnet_crystal_golem ${x} ${y} ${z} 90 ~`)
                }
            }
            if (block.hasTag('v360:jade_crystal_golem')) {
                if (block.hasTag('v360:enorth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:jade_crystal_golem ${x} ${y} ${z} 0 ~`)
                }
                else if (block.hasTag('v360:esouth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:jade_crystal_golem ${x} ${y} ${z} 180 ~`)
                }
                else if (block.hasTag('v360:ewest')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:jade_crystal_golem ${x} ${y} ${z} -90 ~`)
                }
                else if (block.hasTag('v360:eeast')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:jade_crystal_golem ${x} ${y} ${z} 90 ~`)
                }
            }
            if (block.hasTag('v360:calcite_golem')) {
                if (block.hasTag('v360:enorth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:calcite_golem ${x} ${y} ${z} 0 ~`)
                }
                else if (block.hasTag('v360:esouth')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:calcite_golem ${x} ${y} ${z} 180 ~`)
                }
                else if (block.hasTag('v360:ewest')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:calcite_golem ${x} ${y} ${z} -90 ~`)
                }
                else if (block.hasTag('v360:eeast')) {
                    block.setType('air')
                    block.dimension.runCommand(`summon v360:calcite_golem ${x} ${y} ${z} 90 ~`)
                }
            }
        },
        onPlayerInteract({ block }) {
            const goblin = block.permutation.withState('v360:goblin', true)
            const amethyst = block.permutation.withState('v360:amethyst_crystal_golem', true)
            const citrine = block.permutation.withState('v360:citrine_crystal_golem', true)
            const garnet = block.permutation.withState('v360:garnet_crystal_golem', true)
            const jade = block.permutation.withState('v360:jade_crystal_golem', true)
            const calcite = block.permutation.withState('v360:calcite_golem', true)
            if (block.hasTag('v360:goblin')) {
                block.setPermutation(amethyst)
            }
            else if (block.hasTag('v360:amethyst_crystal_golem')) {
                block.setPermutation(citrine)
            }
            else if (block.hasTag('v360:citrine_crystal_golem')) {
                block.setPermutation(garnet)
            }
            else if (block.hasTag('v360:garnet_crystal_golem')) {
                block.setPermutation(jade)
            }
            else if (block.hasTag('v360:jade_crystal_golem')) {
                block.setPermutation(calcite)
            }
            else if (block.hasTag('v360:calcite_golem')) {
                block.setPermutation(goblin)
            }
        }
    })
})