import { world, system, TicksPerSecond } from '@minecraft/server'

const infected_mushroom_stew = [
    'v360:infected_mushroom_stew'
]

const glow_glazed_golden_apple = [
    'v360:glow_glazed_golden_apple'
]

const lush_glazed_golden_apple = [
    'v360:lush_glazed_golden_apple'
]

world.afterEvents.itemCompleteUse.subscribe(event => {
    const { source: entity, itemStack } = event
    if (entity.typeId !== "minecraft:player" || !itemStack || !infected_mushroom_stew.includes(itemStack.typeId)) return;
    entity.addEffect('night_vision', 20, { amplifier: 0, showParticles: true })
    entity.addEffect('resistance', 20, { amplifier: 0, showParticles: true })
})

world.afterEvents.itemCompleteUse.subscribe(event => {
    const { source: entity, itemStack } = event
    if (entity.typeId !== "minecraft:player" || !itemStack || !glow_glazed_golden_apple.includes(itemStack.typeId)) return;
    entity.addEffect('absorption', TicksPerSecond * 120, { amplifier: 0, showParticles: true })
    entity.addEffect('regeneration', TicksPerSecond * 5, { amplifier: 2, showParticles: true })
    entity.addEffect('night_vision', TicksPerSecond * 120, { amplifier: 0, showParticles: true })
})

world.afterEvents.itemCompleteUse.subscribe(event => {
    const { source: entity, itemStack } = event
    if (entity.typeId !== "minecraft:player" || !itemStack || !lush_glazed_golden_apple.includes(itemStack.typeId)) return;
    entity.addEffect('speed', TicksPerSecond * 120, { amplifier: 2, showParticles: true })
    entity.addEffect('haste', TicksPerSecond * 120, { amplifier: 2, showParticles: true })
    entity.addEffect('night_vision', TicksPerSecond * 120, { amplifier: 0, showParticles: true })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:glow_cherries', {
        onConsume({ source }) {
            source.addEffectentity.addEffect('night_vision', TicksPerSecond * 10, { amplifier: 0, showParticles: true })
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:citrined_melon_slice', {
        onConsume({ source }) {
            if (source?.isInWater) {
                source.addEffect('water_breathing', TicksPerSecond * 15, { amplifier: 0, showParticles: true })
            }
            else if (source?.isFalling) {
                source.addEffect('slow_falling', TicksPerSecond * 5, { amplifier: 0, showParticles: true })
            }
            else if (source?.isSneaking) {
                source.addEffect('speed', TicksPerSecond * 10, { amplifier: 0, showParticles: true })
            }
            else if (source?.hasComponent('onfire')) {
                source.addEffect('fire_resistance', TicksPerSecond * 15, { amplifier: 0, showParticles: true })
            }
        }
    })
})