import { world, system, ItemStack } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:ice_with_item', {
        onPlace({ block }) {
            const { x, y, z } = block.location
            block.dimension.spawnEntity('v360:display_item_in_ice', { x: x + 0.5, y: y + 0, z: z + 0.3 })
        }
    })
})

world.afterEvents.entityDie.subscribe(data => {
    const entity = data.deadEntity
    if (entity.typeId === 'v360:display_item_in_ice') {
        entity.triggerEvent('instant_despawn')
    }
})