import { system, world } from '@minecraft/server'

const record_beautiful_cave = 'v360:record_beautiful_cave'

const amethyst_smithing_template = 'v360:amethyst_upgrade_smithing_template'

function checkPlayerInventory() {
    for (const player of world.getPlayers()) {
        const inventory = player.getComponent('minecraft:inventory').container;

        for (let i = 0; i < inventory.size; i++) {
            const item = inventory.getItem(i)

            if (item && item.typeId === record_beautiful_cave) {
                item.setLore([
                    '§r§7Steve Rybakov - Beautiful Cave'
                ])
                inventory.setItem(i, item)
            }
            if (item && item.typeId === amethyst_smithing_template) {
                item.setLore([
                    '§r§7Amethyst Upgrade',
                    '',
                    '§r§7Applies to:',
                    '§r§9 Emerald Armor',
                    '§r§7Ingredients:',
                    '§r§9 Amethyst Shard'
                ])
                inventory.setItem(i, item)
            }
        }
    }
}

system.runInterval(checkPlayerInventory, 20)