import { world, system } from '@minecraft/server'

try {
    world.beforeEvents.worldInitialize.subscribe(initEvent => {
        initEvent.itemComponentRegistry.registerCustomComponent('v360:jade_dagger', {
            onHitEntity({ attackingEntity }) {
                const selectedItem = attackingEntity.getComponent('equippable').getEquipment('Mainhand')
                const { x, y, z } = attackingEntity.getHeadLocation()
                if (attackingEntity && selectedItem?.typeId === 'v360:jade_dagger') {
                    const spwanLoc = { x: x, y: y + 1, z: z }
                    const viewDir = attackingEntity.getViewDirection()
                    const jadeDagger = attackingEntity.dimension.spawnEntity("v360:jade_dagger", spwanLoc)
                    const projectile = jadeDagger.getComponent("projectile")
                    projectile.owner = attackingEntity
                    projectile.shoot(viewDir)
                }
            }
        })
    })

    world.afterEvents.projectileHitEntity.subscribe((data) => {
        const projectile = data.projectile
        const shooter = data.source
        const { x, y, z } = shooter?.location
        const target = data.getEntityHit()
        const targLoc = target.entity.location
        const chance = Math.random()
        if (projectile?.typeId === 'v360:jade_dagger') {
            if (chance < 0.70) {
                target.entity.dimension.spawnEntity('v360:jade', { x: targLoc.x, y: targLoc.y, z: targLoc.z })
                target.entity.dimension.playSound('break.amethyst_cluster', targLoc)
                target.entity.dimension.spawnParticle('v360:jade', targLoc)
                target.entity.applyDamage(Math.random(4, 6))
                target.entity.applyImpulse({ x: 0, y: Math.random(0.1, 0.2), z: 0 })
            }
            else { }
        }
    })
} catch { }