import { world, system, BlockPermutation } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:pointed_icicle_sizes', {
        onPlace({ block }) {
            const tip = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'bottom' })
            const frustum = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'bottom' })
            const middle = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 2, 'minecraft:vertical_half': 'bottom' })
            const base = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 3, 'minecraft:vertical_half': 'bottom' })
            const tip_merge = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 4, 'minecraft:vertical_half': 'bottom' })
            const upTip = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'top' })
            const upFrustum = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'top' })
            const upMiddle = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 2, 'minecraft:vertical_half': 'top' })
            const upBase = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 3, 'minecraft:vertical_half': 'top' })
            const upTip_merge = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 4, 'minecraft:vertical_half': 'top' })
            if (block.hasTag('v360:bottom') && block.below().permutation.matches('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'bottom' })) {
                system.run(() => {
                    block.below().setPermutation(frustum)
                })
            }
            if (block.hasTag('v360:bottom') && block.below(2).permutation.matches('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'bottom' }) && !block.below(3).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'bottom' })) {
                system.run(() => {
                    block.below(2).setPermutation(base)
                })
            }
            if (block.hasTag('v360:bottom') && block.below(2).permutation.matches('v360:pointed_icicle', { 'v360:size': 3, 'minecraft:vertical_half': 'bottom' })) {
                system.run(() => {
                    block.below(2).setPermutation(middle)
                })
            }
            if (block.hasTag('v360:bottom') && block.below().permutation.matches('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'bottom' }) && block.below(2).permutation.matches('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'bottom' }) && block.below(3).permutation.matches('v360:pointed_icicle', { 'v360:size': 3, 'minecraft:vertical_half': 'bottom' })) {
                system.run(() => {
                    block.below(2).setPermutation(middle)
                })
            }
            if (block.hasTag('v360:bottom') && block.below().permutation.matches('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'bottom' }) && block.below(2).permutation.matches('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'bottom' }) && block.below(3).permutation.matches('v360:pointed_icicle', { 'v360:size': 2, 'minecraft:vertical_half': 'bottom' })) {
                system.run(() => {
                    block.below(2).setPermutation(middle)
                })
            }
            if (block.hasTag('v360:top') && block.above().permutation.matches('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'top' })) {
                system.run(() => {
                    block.above().setPermutation(upFrustum)
                })
            }
            if (block.hasTag('v360:top') && block.above(2).permutation.matches('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'top' }) && !block.above(3).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'top' })) {
                system.run(() => {
                    block.above(2).setPermutation(upBase)
                })
            }
            if (block.hasTag('v360:top') && block.above(2).permutation.matches('v360:pointed_icicle', { 'v360:size': 3, 'minecraft:vertical_half': 'top' })) {
                system.run(() => {
                    block.above(2).setPermutation(upMiddle)
                })
            }
            if (block.hasTag('v360:top') && block.above().permutation.matches('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'top' }) && block.above(2).permutation.matches('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'top' }) && block.above(3).permutation.matches('v360:pointed_icicle', { 'v360:size': 3, 'minecraft:vertical_half': 'top' })) {
                system.run(() => {
                    block.above(2).setPermutation(upMiddle)
                })
            }
            if (block.hasTag('v360:top') && block.above().permutation.matches('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'top' }) && block.above(2).permutation.matches('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'top' }) && block.above(3).permutation.matches('v360:pointed_icicle', { 'v360:size': 2, 'minecraft:vertical_half': 'top' })) {
                system.run(() => {
                    block.above(2).setPermutation(upMiddle)
                })
            }
        },
        onPlayerDestroy({ block, destroyedBlockPermutation }) {
            const { x, y, z } = block.location
            const tip = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'bottom' })
            const frustum = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'bottom' })
            const middle = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 2, 'minecraft:vertical_half': 'bottom' })
            const base = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 3, 'minecraft:vertical_half': 'bottom' })
            const tip_merge = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 4, 'minecraft:vertical_half': 'bottom' })
            const upTip = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 0, 'minecraft:vertical_half': 'top' })
            const upFrustum = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 1, 'minecraft:vertical_half': 'top' })
            const upMiddle = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 2, 'minecraft:vertical_half': 'top' })
            const upBase = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 3, 'minecraft:vertical_half': 'top' })
            const upTip_merge = BlockPermutation.resolve('v360:pointed_icicle', { 'v360:size': 4, 'minecraft:vertical_half': 'top' })
            if (destroyedBlockPermutation.hasTag('v360:bottom') && block.below().permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'bottom' })) {
                block.below().setPermutation(tip)
                if (destroyedBlockPermutation.hasTag('v360:bottom') && block.below(2).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'bottom' })) {
                    block.below(2).setPermutation(frustum)
                }
                if (destroyedBlockPermutation.hasTag('v360:bottom') && block.below(3).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'bottom' })) {
                    block.below(3).setPermutation(middle)
                }
                if (destroyedBlockPermutation.hasTag('v360:bottom') && block.below(2).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'bottom' }) && block.below(3).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'bottom' }) && !block.below(4).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'bottom' })) {
                    block.below(2).setPermutation(frustum)
                    block.below(3).setPermutation(base)
                }
            }
            if (destroyedBlockPermutation.hasTag('v360:top') && block.above().permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'top' })) {
                block.above().setPermutation(tip)
                if (destroyedBlockPermutation.hasTag('v360:top') && block.above(2).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'top' })) {
                    block.above(2).setPermutation(upFrustum)
                }
                if (destroyedBlockPermutation.hasTag('v360:top') && block.above(3).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'top' })) {
                    block.above(3).setPermutation(upMiddle)
                }
                if (destroyedBlockPermutation.hasTag('v360:top') && block.above(2).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'top' }) && block.above(3).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'top' }) && !block.above(4).permutation.matches('v360:pointed_icicle', { 'minecraft:vertical_half': 'top' })) {
                    block.above(2).setPermutation(upFrustum)
                    block.above(3).setPermutation(upBase)
                }
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:pointed_icicle_destroy_snow', {
        onTick({ block }) {
            const { x, y, z } = block.location
            if (block.above().typeId === 'minecraft:snow_layer') {
                block.above().setType('air')
            }
            if (block.hasTag('v360:top') && block.above().isAir) {
                block.dimension.runCommand(`fill ${x} ${y} ${z} ${x} ${y - 5} ${z} air [] replace v360:pointed_icicle["minecraft:vertical_half"="top"]`)
            }
        }
    })
})