import { world, system, BlockPermutation, ItemStack } from '@minecraft/server'

world.afterEvents.playerBreakBlock.subscribe(data => {
    const block = data.block
    const player = data.player
    const { x, y, z } = block.location
    const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
    const destroyedBlock = data.brokenBlockPermutation.type.id
    const isPickaxe = selectedItem && selectedItem.hasTag('minecraft:is_pickaxe')
    const blockItem = data.dimension.getEntities({ type: 'minecraft:item', location: block.center(), maxDistance: 0.7 })
    if (!selectedItem?.getComponent('enchantable')?.getEnchantment('silk_touch') && player.getGameMode() === 'creative') return
    else if (selectedItem && selectedItem?.getComponent('enchantable')?.getEnchantment('silk_touch') && player.getGameMode() !== 'creative') {
        if (data.brokenBlockPermutation.hasTag('v360:silk_touch')) {
            blockItem[0].kill()
            if (!data.brokenBlockPermutation.matches('v360:muppet_egg') || !data.brokenBlockPermutation.matches('v360:tabilo_egg')) {
                block.dimension.spawnItem(new ItemStack(`${destroyedBlock}_item`, 1), block.center())
            }
        }
        if (data.brokenBlockPermutation.hasTag('v360:silk_touch_wood') && data.brokenBlockPermutation.hasTag('minecraft:wood_tier_destructible') && (selectedItem?.hasTag('minecraft:is_pickaxe'))) {
            blockItem[0].kill()
            block.dimension.spawnItem(new ItemStack(`${destroyedBlock}_item`, 1), block.center())
        }
        if (data.brokenBlockPermutation.hasTag('v360:silk_touch_stone') && data.brokenBlockPermutation.hasTag('minecraft:stone_tier_destructible') && (selectedItem?.hasTag('minecraft:is_pickaxe') && (!selectedItem?.typeId.includes('minecraft:wooden')))) {
            blockItem[0].kill()
            block.dimension.spawnItem(new ItemStack(`${destroyedBlock}_item`, 1), block.center())
        }
        if (destroyedBlock === 'v360:blueberry_bush' && player.getGameMode() !== 'creative') {
            blockItem[0].kill()
            block.dimension.spawnItem(new ItemStack(`v360:blueberries`, 1), block.center())
        }
        if (destroyedBlock === 'v360:blue_bonnets_waxed0' || destroyedBlock === 'v360:blue_bonnets_waxed1' && player.getGameMode() !== 'creative') {
            blockItem[0].kill()
            block.dimension.spawnItem(new ItemStack(`v360:blue_bonnets_seeds_item`, 1), block.center())
        }
        if (destroyedBlock === 'v360:glow_vine_body_cherries' || destroyedBlock === 'v360:glow_vine_body' || destroyedBlock === 'v360:glow_vine_head_cherries' || destroyedBlock === 'v360:glow_vine' && player.getGameMode() !== 'creative') {
            blockItem[0].kill()
            block.dimension.spawnItem(new ItemStack(`v360:glow_cherries`, 1), block.center())
        }
        if (destroyedBlock === 'v360:glow_root_body' || destroyedBlock === 'v360:glow_root' && player.getGameMode() !== 'creative') {
            blockItem[0].kill()
            block.dimension.spawnItem(new ItemStack(`v360:glow_root_item`, 1), block.center())
        }
        if (destroyedBlock.includes('candlestick') && player.getGameMode() !== 'creative') {
            if (data.brokenBlockPermutation.hasTag('v360:with_no_candle')) {
                blockItem[0].kill()
                block.dimension.spawnItem(new ItemStack(`${destroyedBlock}_item`, 1), block.center())
            }
            if (data.brokenBlockPermutation.hasTag('v360:with_candle')) {
                blockItem[0].kill()
                block.dimension.spawnItem(new ItemStack(`${destroyedBlock}_item`, 1), block.center())
                block.dimension.spawnItem(new ItemStack(`minecraft:candle`, 1), block.center())
            }
        }
    }
})