import { world, system, ItemStack, GameMode } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:trophy_water', {
        onConsume({ source, itemStack }) {
            if (source.hasComponent('minecraft:onfire')) {
                source.extinguishFire(true)
                source.dimension.playSound('random.fizz', source.location)
            }
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:trophy_milk', {
        onConsume({ source }) {
            source.runCommand(`effect @s clear`)
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:trophy_honey', {
        onConsume({ source }) {
            source.removeEffect('poison')
        }
    })
})

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('v360:trophy_block', {
        onPlayerInteract({ block, player }) {
            const waterTrophy = block.typeId.split(':')[1]
            const honeyTrophy = block.typeId.split(':')[1]
            const milkTrophy = block.typeId.split(':')[1]
            const selectedItem = player.getComponent('equippable').getEquipment('Mainhand')
            if (selectedItem?.typeId === 'minecraft:honey_bottle') {
                block.setType('air')
                block.dimension.playSound('bucket.fill_water', block.location)
                block.dimension.spawnItem(new ItemStack(`v360:${honeyTrophy}_honey_item`, 1), block.bottomCenter())
            }
            else if (selectedItem?.typeId === 'minecraft:water_bottle' || selectedItem?.typeId === 'minecraft:water_bucket') {
                block.setType('air')
                block.dimension.playSound('bucket.fill_water', block.location)
                block.dimension.spawnItem(new ItemStack(`v360:${waterTrophy}_water_item`, 1), block.bottomCenter())
            }
            else if (selectedItem?.typeId === 'minecraft:milk_bucket') {
                block.setType('air')
                player.dimension.playSound('mob.cow.milk', player.location)
                block.dimension.spawnItem(new ItemStack(`v360:${milkTrophy}_milk_item`, 1), block.bottomCenter())
            }
        }
    })
})