import { world, system, TicksPerSecond, ItemStack } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.itemComponentRegistry.registerCustomComponent('v360:warp_totem', {
        onUse({ source, itemStack }) {
            const spawnPoint = source.getSpawnPoint()
            if (spawnPoint && source.isOnGround && (!source.isSleeping || !source.isInWater)) {
                source.inputPermissions.movementEnabled = false
                source.dimension.spawnParticle('v360:warp_totem', source.location)
                source.runCommand('playsound item.warp_totem @a[r=10] ~~~ 1 1')
                source.addEffect('weakness', TicksPerSecond * 10, { amplifier: 255, showParticles: false })
                source.addEffect('mining_fatigue', TicksPerSecond * 10, { amplifier: 255, showParticles: false })
                system.runTimeout(() => {
                    source.inputPermissions.movementEnabled = true
                    source.teleport({ x: spawnPoint.x, y: spawnPoint.y, z: spawnPoint.z }, { dimension: spawnPoint.dimension })
                    system.run(() => {
                        source.runCommand('playsound item.citrine_warp @a[r=10] ~~~ 1 1')
                    })
                }, TicksPerSecond * 9)
                if (itemStack?.typeId === 'v360:warp_totem') {
                    source.getComponent('equippable').setEquipment('Mainhand', new ItemStack('v360:one_eyed_warp_totem', 1))
                    source.runCommand('playsound break.amethyst_cluster @a[r=10] ~~~ 1 1')
                    source.startItemCooldown('v360:warp_totem', 24000)
                }
                else if (itemStack?.typeId === 'v360:one_eyed_warp_totem') {
                    source.getComponent('equippable').setEquipment('Mainhand', new ItemStack('v360:empty_warp_totem', 1))
                    source.runCommand('playsound break.amethyst_cluster @a[r=10] ~~~ 1 1')
                    source.startItemCooldown('v360:warp_totem', 24000)
                }
            }
            else if ((source.isSleeping || !source.isOnGround || source.isInWater) && (spawnPoint || !spawnPoint)) {
                world.sendMessage('§7You are not on the ground')
                source.startItemCooldown('v360:warp_totem', 24000)
            }
            else if (!spawnPoint) {
                world.sendMessage('§7No spawn point found')
                source.startItemCooldown('v360:warp_totem', 24000)
            }
        }
    })
})